## fibocom-pc-services 0~git202312251049.1eb588a-1~ubuntu22.04.1

=== application/fibo_flash_service/CMakeLists.txt ===
#/* This program is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http://www.gnu.org/licenses/>.
# *
# * Copyright (C) 2023, Fibocom Wireless Inc.
# */

cmake_minimum_required(VERSION 3.6)

project(fibo_flash_service)

find_package(LibXml2 REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(deps REQUIRED IMPORTED_TARGET glib-2.0 gio-2.0 gio-unix-2.0)

execute_process(COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/FwUpdate.ini ${PROJECT_BINARY_DIR})

set(FLASH_MAJOR_VERSION 1)
set(FLASH_MINOR_VERSION 0)
set(FLASH_PATCH_VERSION 8)

set(FLASH_VERSION_STRING ${FLASH_MAJOR_VERSION}.${FLASH_MINOR_VERSION}.${FLASH_PATCH_VERSION})

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/version.h.in"
                "./version.h")
set(CMAKE_C_COMPILER gcc)
set(FLASH_PREPROCESSOR_DEF "-fstack-protector-strong -O2 -Wformat -Wformat-security  -fPIC -std=gnu99")
add_definitions(${FLASH_PREPROCESSOR_DEF})

find_program(GDBUSCODEGEN NAMES gdbus-codegen)
if (NOT GDBUSCODEGEN)
	message(SEND_ERROR "Could not find gdbus-codegen")
endif(NOT GDBUSCODEGEN)

add_custom_command(OUTPUT generated/fibocom-helper-gdbus-generated.c
        COMMAND ${GDBUSCODEGEN}  --generate-c-code=fibocom-helper-gdbus-generated --c-namespace=FibocomGdbus --interface-prefix com.fibocom. ${CMAKE_SOURCE_DIR}/application/dbus/introspection/com.fibocom.helper.xml
        COMMAND mkdir -p generated/
        COMMAND mv fibocom-helper-gdbus-generated.c generated/
        )
##################################
# Fibocom linux flash service binary configuration
include_directories(${PROJECT_BINARY_DIR}/)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../include)
include_directories(${CMAKE_SOURCE_DIR}/application/include/common)
include_directories(${PROJECT_BINARY_DIR}/../3rd/safestringlib)

set(source_files
    fibo_flash_main.c fibo_flash_parse_xml.c generated/fibocom-helper-gdbus-generated.c)

add_executable(fibo_flash
    ${source_files})

target_link_libraries(fibo_flash ${PROJECT_BINARY_DIR}/../3rd/safestringlib/libsafestring_static.a)

target_link_libraries(fibo_flash
    PkgConfig::deps
    LibXml2::LibXml2)

=== debian/changelog ===
fibocom-pc-services (0~git202312251049.1eb588a-1~ubuntu22.04.1) jammy; urgency=medium

  * Initial release

 -- Kai-Chuan Hsieh <kaichuan.hsieh@canonical.com>  Fri, 15 Dec 2023 14:24:10 +0800

=== debian/control ===
Source: fibocom-pc-services
Section: net
Priority: optional
Maintainer: Commercial Engineers <commercial-engineering@canonical.com>
Build-Depends:
 debhelper-compat (= 13),
 dh-modaliases,
 cmake,
 build-essential,
 pkg-config,
 libglib2.0-dev,
 libxml2-dev,
 libudev-dev,
 libmbim-glib-dev,
 libdbus-1-dev,
 libmm-glib-dev,
 udev,
Standards-Version: 4.6.0
Homepage: https://github.com/fibocom-pc/linux_apps_opensource
Vcs-Browser: https://github.com/fibocom-pc/linux_apps_opensource
Vcs-Git: https://github.com/fibocom-pc/linux_apps_opensource.git
Rules-Requires-Root: no

Package: fibocom-helper-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, modemmanager
Description: DBus API provider for Flash/Ma/Config service
 The package provides DBus API for Flash/Ma/Config service to communicate to
 the modem.

Package: fibocom-config-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
XB-Modaliases: ${modaliases}
Description: OEM configuration functions for Fibocom modem
 The service provides OEM configurations functions.

Package: fibocom-ma-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
XB-Modaliases: ${modaliases}
Description: Provide fccunlock function for Fibocom modem
 The service provides fccunlock function for fibocom modem.

Package: fibocom-flash-service
Architecture: any
Recommends: fibocom-firmware, fastboot
Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
XB-Modaliases: ${modaliases}
Description: Provide firmware flash function for Fibocom modem
 The service provides firmware flash function for fibocom modem.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --with modaliases

current_dir=$(shell pwd)
# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=. --builddirectory=build -- \
	    --install-prefix="$(current_dir)/debian/tmp"

override_dh_auto_build:
	cmake --build build

override_dh_auto_install:
	cmake --install build

override_dh_installsystemd:
	dh_installsystemd -pfibocom-helper-service --name=fibo_helper fibo_helper.service
	dh_installsystemd -pfibocom-helper-service --name=fibo_helper_mbim fibo_helper_mbim.service
	dh_installsystemd -pfibocom-flash-service --name=fibo_flash fibo_flash.service
	dh_installsystemd -pfibocom-config-service --name=fibo_config fibo_config.service

override_dh_auto_clean:
	dh_auto_clean -- \
	    rm -rf debian/tmp
	    rm -rf build/

## fibocom-pc-services 0~git202312251049.1eb588a-1~ubuntu22.04.10

=== CMakeLists.txt ===
#/* This program is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http://www.gnu.org/licenses/>.
# *
# * Copyright (C) 2023, Fibocom Wireless Inc.
# */

cmake_minimum_required(VERSION 3.6)

# Note: project version is the fibocom-linux version. Update this as per below description
# It is three part.
# <major>.<minor>.<macro>
# major = If any significant design change that improves complete.
# minor = Small design change specific to any operation.
# macro = small change or bug fix

project(fibocom_linux VERSION 1.0.8)

add_subdirectory (application)

# enable_testing()
# add_subdirectory(test)

install(CODE "MESSAGE(\"start install script.\")")
install(CODE "execute_process(COMMAND bash ${PROJECT_SOURCE_DIR}/install)")
install(CODE "MESSAGE(\"run install script success.\")")

set(DEFAULT_INSTALL_PREFIX "")

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX ${DEFAULT_INSTALL_PREFIX} CACHE PATH "Default installation path" FORCE)
endif()
message(STATUS "Installation prefix: ${CMAKE_INSTALL_PREFIX}")  

install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/opt/fibocom" FILE_PERMISSIONS  OWNER_EXECUTE OWNER_WRITE OWNER_READ DESTINATION "${CMAKE_INSTALL_PREFIX}/opt")
install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/usr/lib/udev/rules.d/" DESTINATION "${CMAKE_INSTALL_PREFIX}/usr/lib/udev/rules.d")
# install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/usr/lib/x86_64-linux-gnu/ModemManager/fcc-unlock.d/"  
#             FILE_PERMISSIONS    OWNER_EXECUTE OWNER_WRITE OWNER_READ
#                                 GROUP_EXECUTE GROUP_READ 
#                                 WORLD_EXECUTE WORLD_READ
#             DESTINATION "${CMAKE_INSTALL_PREFIX}/usr/lib/x86_64-linux-gnu/ModemManager/fcc-unlock.d")
install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/lib/systemd/system/" DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/systemd/system")
install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/usr/share/dbus-1/system.d/" DESTINATION "${CMAKE_INSTALL_PREFIX}/usr/share/dbus-1/system.d")
install(CODE "MESSAGE(\"install success!\")")


set(CPACK_GENERATOR "DEB")
set(CPACK_PACKAGE_NAME "linux-apps")
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_DEBIAN_PACKAGE_GROUP "fibocom")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "WWAN Linux apps")
set(CPACK_DEBIAN_PACKAGE_SECTION "base")
set(CPACK_DEBIAN_PACKAGE_PRIORITY "standard")
set(CPACK_PACKAGE_VENDOR "fibocom")
set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Fibocom")
set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA 
    "${PROJECT_BINARY_DIR}/../script/preinst;${PROJECT_BINARY_DIR}/../script/prerm;${PROJECT_BINARY_DIR}/../script/postinst;${PROJECT_BINARY_DIR}/../script/postrm")
include(CPack)


configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
  @ONLY
)

add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== application/3rd/CMakeLists.txt ===
#/* This program is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http://www.gnu.org/licenses/>.
# *
# * Copyright (C) 2023, Fibocom Wireless Inc.
# */

cmake_minimum_required(VERSION 3.6)

project(3rd)

add_subdirectory(iniparser)
add_subdirectory(safestringlib)
add_subdirectory(qdl)

=== application/fibo_helper_service/CMakeLists.txt ===
#/* This program is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http://www.gnu.org/licenses/>.
# *
# * Copyright (C) 2023, Fibocom Wireless Inc.
# */

cmake_minimum_required(VERSION 3.6)

project(fibo_helper_service)

find_package(PkgConfig REQUIRED)
find_package(LibXml2 REQUIRED)
pkg_check_modules(deps REQUIRED IMPORTED_TARGET glib-2.0 gio-2.0 gio-unix-2.0 udev)

##################################
# Fibocom linux Gdbus codegen

find_program(GDBUSCODEGEN NAMES gdbus-codegen)
if (NOT GDBUSCODEGEN)
    message(SEND_ERROR "Could not find gdbus-codegen")
endif(NOT GDBUSCODEGEN)

add_custom_command(OUTPUT generated/fibocom-helper-gdbus-generated.c
    COMMAND ${GDBUSCODEGEN}  --generate-c-code=fibocom-helper-gdbus-generated --c-namespace=FibocomGdbus --interface-prefix com.fibocom. ${CMAKE_SOURCE_DIR}/application/dbus/introspection/com.fibocom.helper.xml
    COMMAND mkdir -p generated/
    COMMAND mv fibocom-helper-gdbus-generated.c generated/
    )
include_directories(${CMAKE_SOURCE_DIR}/application/include/common)

set(HELPER_MAJOR_VERSION 1)
set(HELPER_MINOR_VERSION 0)
set(HELPER_PATCH_VERSION 8)

set(HELPER_VERSION_STRING ${HELPER_MAJOR_VERSION}.${HELPER_MINOR_VERSION}.${HELPER_PATCH_VERSION})
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/version.h.in"
                "./version.h")
set(CMAKE_C_COMPILER gcc)
set(HELPER_PREPROCESSOR_DEF "-fstack-protector-strong -O2 -Wformat -Wformat-security  -fPIC -std=gnu99")
##################################
# Fibocom linux helper service binary configuration

add_compile_options(-pthread)
include_directories(${PROJECT_BINARY_DIR}/)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../include
                    /usr/include/dbus-1.0
                    /usr/lib/x86_64-linux-gnu/dbus-1.0/include
                    /usr/include/gio-unix-2.0
                    /usr/include/libmount
                    /usr/include/blkid
                    /usr/include/glib-2.0
                    /usr/lib/x86_64-linux-gnu/glib-2.0/include
                    /usr/local/include/libmbim-glib
                    /usr/include/libmbim-glib
                    /usr/include/libmm-glib
                    /usr/include/ModemManager
                    ${CMAKE_CURRENT_SOURCE_DIR})

set(helperd_source_files
    fibo_helper_main.c
    fibo_helper_basic_func.c
    fibo_helper_adapter.c
        fibo_helper_log.c
        generated/fibocom-helper-gdbus-generated.c
    )

set(helperm_source_files
    fibo_helper_mbim_main.c
    fibo_helper_basic_func.c
    fibo_helper_adapter.c
        fibo_helper_log.c
        generated/fibocom-helper-gdbus-generated.c
    )

add_subdirectory(./at_channel code)

add_definitions(${HELPER_PREPROCESSOR_DEF})
add_executable(fibo_helperd
    ${helperd_source_files})

add_executable(fibo_helperm
    ${helperm_source_files})

target_link_libraries(fibo_helperd
            code
            libmbim-glib.so
            dbus-1
            udev
            gio-2.0
            gobject-2.0
            glib-2.0
            mm-glib
            PkgConfig::deps
            LibXml2::LibXml2)

target_link_libraries(fibo_helperm
            code
            libmbim-glib.so
            dbus-1
            udev
            gio-2.0
            gobject-2.0
            glib-2.0
            mm-glib
            PkgConfig::deps
            LibXml2::LibXml2)

=== application/3rd/iniparser/CMakeLists.txt ===
#/* This program is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http://www.gnu.org/licenses/>.
# *
# * Copyright (C) 2023, Fibocom Wireless Inc.
# */

cmake_minimum_required(VERSION 3.6)

project(iniparser)
set(path ${CMAKE_CURRENT_SOURCE_DIR}/src/dictionary.h
            ${CMAKE_CURRENT_SOURCE_DIR}/src/iniparser.h)
execute_process(COMMAND cp -raf ${path}  ${PROJECT_BINARY_DIR})

include_directories (./src DIR_LIB_INCLUDES)
aux_source_directory(./src DIR_LIB_SRCS)

add_library(iniparser ${DIR_LIB_SRCS})

=== application/3rd/qdl/CMakeLists.txt ===
#/* This program is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http://www.gnu.org/licenses/>.
# *
# * Copyright (C) 2023, Fibocom Wireless Inc.
# */

cmake_minimum_required(VERSION 3.6)

project(qdl)
find_package(LibXml2 REQUIRED)

include_directories (. DIR_LIB_INCLUDES)
aux_source_directory(. DIR_LIB_SRCS)

set(qdl_source_files firehose.c qdl.c sahara.c util.c patch.c program.c ufs.c)

set(ks_source_files ks.c sahara.c util.c)

include_directories(/usr/include/libxml2)

add_executable(ks ${ks_source_files})
add_executable(qdl ${qdl_source_files})

target_link_libraries(qdl LibXml2::LibXml2 udev)
target_link_libraries(ks LibXml2::LibXml2 udev)

=== application/3rd/qdl/Makefile ===
OUT := qdl

CFLAGS := -O2 -Wall -g `pkg-config --cflags libxml-2.0`
LDFLAGS := `pkg-config --libs libxml-2.0 libudev`
prefix := /usr/local

SRCS := firehose.c qdl.c sahara.c util.c patch.c program.c ufs.c
OBJS := $(SRCS:.c=.o)

KS_OUT := ks
KS_SRCS := ks.c sahara.c util.c
KS_OBJS := $(KS_SRCS:.c=.o)

default: $(OUT) $(KS_OUT)

$(OUT): $(OBJS)
	$(CC) -o $@ $^ $(LDFLAGS)

$(KS_OUT): $(KS_OBJS)
	$(CC) -o $@ $^ $(LDFLAGS)

clean:
	rm -f $(OUT) $(OBJS)
	rm -f $(KS_OUT) $(KS_OBJS)

install: $(OUT) $(KS_OUT)
	install -d $(DESTDIR)$(prefix)/bin
	install -m 755 $^ $(DESTDIR)$(prefix)/bin

=== application/3rd/safestringlib/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
# Copyright (C) 2019-2023 Intel Corporation
cmake_minimum_required(VERSION 3.5)

include(version.cmake)

project(safestring
  VERSION ${SAFEC_VERSION_STRING}
  DESCRIPTION "Safe C string library"
)

option(BUILD_UNITTESTS "Build also project unit-tests" OFF)

if(NOT DEFINED BUILD_OPT_DEFAULT)
  option(BUILD_OPT_DEFAULT "Build option default" ON)
endif()

option(BUILD_MEMCMP "Build memcmp* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_MEMCPY "Build memcpy* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_MEMMOVE "Build memmove* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_MEMSET "Build memset* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_MEMZERO "Build memzero* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STPCPY "Build stpcpy* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STPNCPY "Build stpncpy* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCASECMP "Build strcasecmp* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCASESTR "Build strcasestr* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCAT "Build strcat* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCMPFLD "Build strcmpfld* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCMP "Build strcmp* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCPYFLDIN "Build strcpyfldin* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCPYFLDOUT "Build strcpyfldout* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCPYFLD "Build strcpyfld* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCPY "Build strcpy* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRCSPN "Build strcspn* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRFIRSTCHAR "Build strfirstchar* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRFIRSTDIFF "Build strfirstdiff* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRFIRSTSAME "Build strfirstsame* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRISALPHANUMERIC "Build strisalphanumeric* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRISASCII "Build strisascii* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRISDIGIT "Build strisdigit* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRISHEX "Build strishex* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRISLOWERCASE "Build strislowercase* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRISMIXEDCASE "Build strismixedcase* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRISPASSWORD "Build strispassword* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRISUPPERCASE "Build strisuppercase* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRLASTCHAR "Build strlastchar* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRLASTDIFF "Build strlastdiff* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRLASTSAME "Build strlastsame* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRLJUSTIFY "Build strljustify* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRNCAT "Build strncat* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRNCPY "Build strncpy* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRNLEN "Build strnlen* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRNTERMINATE "Build strnterminate* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRPBRK "Build strpbrk* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRPREFIX "Build strprefix* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRREMOVEWS "Build strremovews* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRSPN "Build strspn* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRSTR "Build strstr* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRTOK "Build strtok* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRTOLOWERCASE "Build strtolowercase* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRTOUPPERCASE "Build strtouppercase* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_STRZERO "Build strzero* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WCPCPY "Build wcpcpy* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WCSCAT "Build wcscat* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WCSCPY "Build wcscpy* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WCSNCAT "Build wcsncat* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WCSNCPY "Build wcsncpy* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WCSNLEN "Build wcsnlen* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WMEMCMP "Build wmemcmp* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WMEMCPY "Build wmemcpy* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WMEMMOVE "Build wmemmove* functions" ${BUILD_OPT_DEFAULT})
option(BUILD_WMEMSET "Build wmemset* functions" ${BUILD_OPT_DEFAULT})

set(SOURCES
    safeclib/abort_handler_s.c
    safeclib/ignore_handler_s.c
    $<$<BOOL:${BUILD_MEMCMP}>:safeclib/memcmp16_s.c>
    $<$<BOOL:${BUILD_MEMCMP}>:safeclib/memcmp32_s.c>
    $<$<BOOL:${BUILD_MEMCMP}>:safeclib/memcmp_s.c>
    $<$<BOOL:${BUILD_MEMCPY}>:safeclib/memcpy16_s.c>
    $<$<BOOL:${BUILD_MEMCPY}>:safeclib/memcpy32_s.c>
    $<$<BOOL:${BUILD_MEMCPY}>:safeclib/memcpy_s.c>
    $<$<BOOL:${BUILD_MEMMOVE}>:safeclib/memmove16_s.c>
    $<$<BOOL:${BUILD_MEMMOVE}>:safeclib/memmove32_s.c>
    $<$<BOOL:${BUILD_MEMMOVE}>:safeclib/memmove_s.c>
    safeclib/mem_primitives_lib.c
    $<$<BOOL:${BUILD_MEMSET}>:safeclib/memset16_s.c>
    $<$<BOOL:${BUILD_MEMSET}>:safeclib/memset32_s.c>
    $<$<BOOL:${BUILD_MEMSET}>:safeclib/memset_s.c>
    $<$<BOOL:${BUILD_MEMZERO}>:safeclib/memzero16_s.c>
    $<$<BOOL:${BUILD_MEMZERO}>:safeclib/memzero32_s.c>
    $<$<BOOL:${BUILD_MEMZERO}>:safeclib/memzero_s.c>
    safeclib/safe_mem_constraint.c
    safeclib/safe_str_constraint.c
    safeclib/snprintf_support.c
    $<$<BOOL:${BUILD_STPCPY}>:safeclib/stpcpy_s.c>
    $<$<BOOL:${BUILD_STPNCPY}>:safeclib/stpncpy_s.c>
    $<$<BOOL:${BUILD_STRCASECMP}>:safeclib/strcasecmp_s.c>
    $<$<BOOL:${BUILD_STRCASESTR}>:safeclib/strcasestr_s.c>
    $<$<BOOL:${BUILD_STRCAT}>:safeclib/strcat_s.c>
    $<$<BOOL:${BUILD_STRCMPFLD}>:safeclib/strcmpfld_s.c>
    $<$<BOOL:${BUILD_STRCMP}>:safeclib/strcmp_s.c>
    $<$<BOOL:${BUILD_STRCPYFLDIN}>:safeclib/strcpyfldin_s.c>
    $<$<BOOL:${BUILD_STRCPYFLDOUT}>:safeclib/strcpyfldout_s.c>
    $<$<BOOL:${BUILD_STRCPYFLD}>:safeclib/strcpyfld_s.c>
    $<$<BOOL:${BUILD_STRCPY}>:safeclib/strcpy_s.c>
    $<$<BOOL:${BUILD_STRCSPN}>:safeclib/strcspn_s.c>
    $<$<BOOL:${BUILD_STRFIRSTCHAR}>:safeclib/strfirstchar_s.c>
    $<$<BOOL:${BUILD_STRFIRSTDIFF}>:safeclib/strfirstdiff_s.c>
    $<$<BOOL:${BUILD_STRFIRSTSAME}>:safeclib/strfirstsame_s.c>
    $<$<BOOL:${BUILD_STRISALPHANUMERIC}>:safeclib/strisalphanumeric_s.c>
    $<$<BOOL:${BUILD_STRISASCII}>:safeclib/strisascii_s.c>
    $<$<BOOL:${BUILD_STRISDIGIT}>:safeclib/strisdigit_s.c>
    $<$<BOOL:${BUILD_STRISHEX}>:safeclib/strishex_s.c>
    $<$<BOOL:${BUILD_STRISLOWERCASE}>:safeclib/strislowercase_s.c>
    $<$<BOOL:${BUILD_STRISMIXEDCASE}>:safeclib/strismixedcase_s.c>
    $<$<BOOL:${BUILD_STRISPASSWORD}>:safeclib/strispassword_s.c>
    $<$<BOOL:${BUILD_STRISUPPERCASE}>:safeclib/strisuppercase_s.c>
    $<$<BOOL:${BUILD_STRLASTCHAR}>:safeclib/strlastchar_s.c>
    $<$<BOOL:${BUILD_STRLASTDIFF}>:safeclib/strlastdiff_s.c>
    $<$<BOOL:${BUILD_STRLASTSAME}>:safeclib/strlastsame_s.c>
    $<$<BOOL:${BUILD_STRLJUSTIFY}>:safeclib/strljustify_s.c>
    $<$<BOOL:${BUILD_STRNCAT}>:safeclib/strncat_s.c>
    $<$<BOOL:${BUILD_STRNCPY}>:safeclib/strncpy_s.c>
    $<$<BOOL:${BUILD_STRNLEN}>:safeclib/strnlen_s.c>
    $<$<BOOL:${BUILD_STRNTERMINATE}>:safeclib/strnterminate_s.c>
    $<$<BOOL:${BUILD_STRPBRK}>:safeclib/strpbrk_s.c>
    $<$<BOOL:${BUILD_STRPREFIX}>:safeclib/strprefix_s.c>
    $<$<BOOL:${BUILD_STRREMOVEWS}>:safeclib/strremovews_s.c>
    $<$<BOOL:${BUILD_STRSPN}>:safeclib/strspn_s.c>
    $<$<BOOL:${BUILD_STRSTR}>:safeclib/strstr_s.c>
    $<$<BOOL:${BUILD_STRTOK}>:safeclib/strtok_s.c>
    $<$<BOOL:${BUILD_STRTOLOWERCASE}>:safeclib/strtolowercase_s.c>
    $<$<BOOL:${BUILD_STRTOUPPERCASE}>:safeclib/strtouppercase_s.c>
    $<$<BOOL:${BUILD_STRZERO}>:safeclib/strzero_s.c>
    $<$<BOOL:${BUILD_WCPCPY}>:safeclib/wcpcpy_s.c>
    $<$<BOOL:${BUILD_WCSCAT}>:safeclib/wcscat_s.c>
    $<$<BOOL:${BUILD_WCSCPY}>:safeclib/wcscpy_s.c>
    $<$<BOOL:${BUILD_WCSNCAT}>:safeclib/wcsncat_s.c>
    $<$<BOOL:${BUILD_WCSNCPY}>:safeclib/wcsncpy_s.c>
    $<$<BOOL:${BUILD_WCSNLEN}>:safeclib/wcsnlen_s.c>
    $<$<BOOL:${BUILD_WMEMCMP}>:safeclib/wmemcmp_s.c>
    $<$<BOOL:${BUILD_WMEMCPY}>:safeclib/wmemcpy_s.c>
    $<$<BOOL:${BUILD_WMEMMOVE}>:safeclib/wmemmove_s.c>
    $<$<BOOL:${BUILD_WMEMSET}>:safeclib/wmemset_s.c>
    )

include_directories(include)

add_library(${PROJECT_NAME}_objlib OBJECT ${SOURCES})
set_target_properties(${PROJECT_NAME}_objlib
                      PROPERTIES POSITION_INDEPENDENT_CODE ON)

target_compile_definitions(${PROJECT_NAME}_objlib PRIVATE -DSTDC_HEADERS)

target_compile_options(${PROJECT_NAME}_objlib
                       PRIVATE -Wno-unknown-pragmas -Wno-unused-parameter)
if(CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 7)
  target_compile_options(${PROJECT_NAME}_objlib
                         PRIVATE -Wno-implicit-fallthrough)
endif()
target_compile_options(${PROJECT_NAME}_objlib
                       PRIVATE -Wall -Wextra -Wsign-compare -Wformat-security)
target_compile_options(${PROJECT_NAME}_objlib
                       PRIVATE  -Wstack-protector -Winit-self)
target_compile_options(${PROJECT_NAME}_objlib
                       PRIVATE -D_FORTIFY_SOURCE=2 -O2)
target_compile_options(${PROJECT_NAME}_objlib
                       PRIVATE -fstack-protector-all)
target_compile_options(${PROJECT_NAME}_objlib
                       PRIVATE --param ssp-buffer-size=4 -ftrapv)
target_compile_options(${PROJECT_NAME}_objlib PRIVATE -fPIE -fPIC)

if(CMAKE_COMPILER_IS_GNUCC AND
   CMAKE_C_COMPILER_VERSION VERSION_GREATER 6 AND
   CMAKE_C_COMPILER_VERSION VERSION_LESS 9)
    target_compile_options(${PROJECT_NAME}_objlib PRIVATE -mmitigate-rop)
endif()
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z noexecstack -z relro -z now")

option(BUILD_ERROR_ON_WARNING "Fail compilation on warning" OFF)

if(BUILD_ERROR_ON_WARNING)
    target_compile_options(${PROJECT_NAME}_objlib PRIVATE -Werror)
endif()

target_compile_options(${PROJECT_NAME}_objlib PRIVATE $<$<CONFIG:RELEASE>:-s>)

add_library(${PROJECT_NAME}_shared SHARED $<TARGET_OBJECTS:${PROJECT_NAME}_objlib>)
add_library(${PROJECT_NAME}_static STATIC $<TARGET_OBJECTS:${PROJECT_NAME}_objlib>)

target_include_directories(${PROJECT_NAME}_shared PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_include_directories(${PROJECT_NAME}_static PUBLIC include)

set_target_properties(${PROJECT_NAME}_shared PROPERTIES VERSION ${SAFEC_VERSION_STRING})
set_target_properties(${PROJECT_NAME}_static PROPERTIES VERSION ${SAFEC_VERSION_STRING})

if(BUILD_UNITTESTS)
  add_subdirectory(unittests)
endif()

# Install targets
set(PUBLIC_HEADERS
${CMAKE_CURRENT_SOURCE_DIR}/include/safe_lib_errno.h
${CMAKE_CURRENT_SOURCE_DIR}/include/safe_lib.h
${CMAKE_CURRENT_SOURCE_DIR}/include/safe_mem_lib.h
${CMAKE_CURRENT_SOURCE_DIR}/include/safe_str_lib.h
${CMAKE_CURRENT_SOURCE_DIR}/include/safe_types.h
${CMAKE_CURRENT_SOURCE_DIR}/include/snprintf_s.h
)
execute_process(COMMAND cp -raf /${PUBLIC_HEADERS} ${PROJECT_BINARY_DIR})

# set_target_properties(${PROJECT_NAME}_shared PROPERTIES
#   PUBLIC_HEADER "${PUBLIC_HEADERS}"
# )

# install(TARGETS ${PROJECT_NAME}_shared EXPORT ${PROJECT_NAME}Config
#   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
#   PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
# )

# install(EXPORT ${PROJECT_NAME}Config DESTINATION share/${PROJECT_NAME}/cmake)

# export(TARGETS ${PROJECT_NAME}_shared FILE ${PROJECT_NAME}Config.cmake)

# # Debian package information for CPack
# set(CPACK_GENERATOR "DEB")
# set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Intel")
# set(CPACK_PACKAGE_VERSION_MAJOR "${SAFEC_VERSION_MAJOR}")
# set(CPACK_PACKAGE_VERSION_MINOR "${SAFEC_VERSION_MINOR}")
# set(CPACK_PACKAGE_VERSION_PATCH "${SAFEC_VERSION_PATCH}")
# set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "SafeStringLib is an Intel enhanced version of the Safe C Library by Cisco.")

=== application/fibo_helper_service/at_channel/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(code LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
add_library(code  STATIC common.cc  serial_port.cc)

=== application/3rd/safestringlib/debian/changelog ===
safestringlib (1.0.0-1) UNRELEASED; urgency=low

  * Initial release as Debian package.

 -- Francois Dugast <francois.dugast@intel.com>  Fri, 05 Mar 2021 12:19:50 +0000

=== debian/changelog ===
fibocom-pc-services (0~git202312251049.1eb588a-1~ubuntu22.04.10) jammy; urgency=medium

  * Initial release

 -- Kai-Chuan Hsieh <kaichuan.hsieh@canonical.com>  Wed, 03 Sep 2025 14:29:50 +0800

=== application/3rd/safestringlib/debian/control ===
Source: safestringlib
Section: libs
Priority: optional
Maintainer: Francois Dugast <francois.dugast@intel.com>
Build-Depends: cmake, debhelper (>=11~)
Standards-Version: 4.1.4
Homepage: https://01.org/safestring-library
Vcs-Git: https://github.com/intel/safestringlib

Package: safestringlib
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: The Safe String Library is a C Library
 providing string and memory buffer routines that
 protect against buffer overflows.

Package: safestringlib-dev
Architecture: any
Multi-Arch: foreign
Depends: safestringlib ${misc:Depends}, ${shlibs:Depends}
Description: The Safe String Library is a C Library
 providing string and memory buffer routines that
 protect against buffer overflows. This package contains
 the development files.

=== debian/rules ===
--- 
+++ 
@@ -35,6 +35,11 @@
 	dh_installsystemd -pfibocom-helper-service --name=fibo_helper_mbim fibo_helper_mbim.service
 	dh_installsystemd -pfibocom-flash-service --name=fibo_flash fibo_flash.service
 	dh_installsystemd -pfibocom-config-service --name=fibo_config fibo_config.service
+	dh_installsystemd -pfibocom-ma-service --name=fibo_ma --no-start fibo_ma.service
+
+override_dh_installdeb:
+	dh_apparmor --profile-name=opt.fibocom.fibo_ma_service.fibo_ma -pfibocom-ma-service
+	dh_installdeb
 
 override_dh_auto_clean:
 	dh_auto_clean -- \

## fibocom-pc-services 0~git202508291421.319e058-1~ubuntu22.04.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
 # minor = Small design change specific to any operation.
 # macro = small change or bug fix
 
-project(fibocom_linux VERSION 1.0.8)
+project(fibocom_linux VERSION 1.0.12)
 
 add_subdirectory (application)

=== application/CMakeLists.txt ===
#/* This program is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http://www.gnu.org/licenses/>.
# *
# * Copyright (C) 2023, Fibocom Wireless Inc.
# */

cmake_minimum_required(VERSION 3.6)

add_subdirectory(3rd)
add_subdirectory(fibo_helper_service)
add_subdirectory(fibo_flash_service)
add_subdirectory(fibo_config_service)

=== application/fibo_config_service/CMakeLists.txt ===
#/* This program is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http://www.gnu.org/licenses/>.
# *
# * Copyright (C) 2023, Fibocom Wireless Inc.
# */

cmake_minimum_required(VERSION 3.6)

project(fibo_config_service)

find_package(LibXml2 REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(deps REQUIRED IMPORTED_TARGET glib-2.0 gio-2.0 gio-unix-2.0)


find_program(GDBUSCODEGEN NAMES gdbus-codegen)
if (NOT GDBUSCODEGEN)
	message(SEND_ERROR "Could not find gdbus-codegen")
endif(NOT GDBUSCODEGEN)

add_custom_command(OUTPUT generated/fibocom-helper-gdbus-generated.c
	COMMAND ${GDBUSCODEGEN}  --generate-c-code=fibocom-helper-gdbus-generated --c-namespace=FibocomGdbus --interface-prefix com.fibocom. ${CMAKE_SOURCE_DIR}/application/dbus/introspection/com.fibocom.helper.xml
	COMMAND mkdir -p generated/
	COMMAND mv fibocom-helper-gdbus-generated.c generated/
	)

execute_process(COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/fbwwanConfig.ini ${PROJECT_BINARY_DIR})
set(CONFIG_MAJOR_VERSION 1)
set(CONFIG_MINOR_VERSION 0)
set(CONFIG_PATCH_VERSION 3)

set(CONFIG_VERSION_STRING "${CONFIG_MAJOR_VERSION}.${CONFIG_MINOR_VERSION}.${CONFIG_PATCH_VERSION}")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/version.h.in"
                "./version.h")

set(CMAKE_C_COMPILER gcc)
set(CONFIG_PREPROCESSOR_DEF "-fstack-protector-strong -O2 -Wformat -Wformat-security  -fPIC -std=gnu99")
add_definitions(${CONFIG_PREPROCESSOR_DEF})

##################################
# Fibocom linux config service binary configuration

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../include)

include_directories(${CMAKE_SOURCE_DIR}/application/include/common)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${PROJECT_BINARY_DIR}/)
include_directories(${PROJECT_BINARY_DIR}/../3rd/iniparser)

include_directories(/usr/include/dbus-1.0
                    /usr/lib/x86_64-linux-gnu/dbus-1.0/include
                    /usr/include/gio-unix-2.0
                    /usr/include/libmount
                    /usr/include/blkid
                    /usr/include/glib-2.0
					/usr/include/libxml2
                    /usr/lib/x86_64-linux-gnu/glib-2.0/include)


aux_source_directory(./src DIR_SRCS)
set(source_files generated/fibocom-helper-gdbus-generated.c)

add_executable(fibo_config ${DIR_SRCS} ${source_files})

target_link_libraries(fibo_config ${PROJECT_BINARY_DIR}/../3rd/iniparser/libiniparser.a)
target_link_libraries(fibo_config  LibXml2::LibXml2 -ldl -lpthread -lm PkgConfig::deps ${CMAKE_DL_LIBS})

=== application/fibo_flash_service/CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
 
 set(FLASH_MAJOR_VERSION 1)
 set(FLASH_MINOR_VERSION 0)
-set(FLASH_PATCH_VERSION 8)
+set(FLASH_PATCH_VERSION 9)
 
 set(FLASH_VERSION_STRING ${FLASH_MAJOR_VERSION}.${FLASH_MINOR_VERSION}.${FLASH_PATCH_VERSION})

=== application/fibo_helper_service/CMakeLists.txt ===
--- 
+++ 
@@ -39,7 +39,7 @@
 
 set(HELPER_MAJOR_VERSION 1)
 set(HELPER_MINOR_VERSION 0)
-set(HELPER_PATCH_VERSION 8)
+set(HELPER_PATCH_VERSION 9)
 
 set(HELPER_VERSION_STRING ${HELPER_MAJOR_VERSION}.${HELPER_MINOR_VERSION}.${HELPER_PATCH_VERSION})
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/version.h.in"

=== application/3rd/safestringlib/unittests/CMakeLists.txt ===
# SPDX-License-Identifier: MIT
# Copyright (C) 2019 Intel Corporation
cmake_minimum_required(VERSION 3.1)
project(safestring_test)

set(SOURCES
  Safe_String_UnitTestMain.c
  $<$<BOOL:${BUILD_MEMCMP}>:test_memcmp16_s.c>
  $<$<BOOL:${BUILD_MEMCMP}>:test_memcmp32_s.c>
  $<$<BOOL:${BUILD_MEMCMP}>:test_memcmp_s.c>
  $<$<BOOL:${BUILD_MEMCPY}>:test_memcpy16_s.c>
  $<$<BOOL:${BUILD_MEMCPY}>:test_memcpy32_s.c>
  $<$<BOOL:${BUILD_MEMCPY}>:test_memcpy_s.c>
  $<$<BOOL:${BUILD_MEMMOVE}>:test_memmove16_s.c>
  $<$<BOOL:${BUILD_MEMMOVE}>:test_memmove32_s.c>
  $<$<BOOL:${BUILD_MEMMOVE}>:test_memmove_s.c>
  $<$<BOOL:${BUILD_MEMSET}>:test_memset16_s.c>
  $<$<BOOL:${BUILD_MEMSET}>:test_memset32_s.c>
  $<$<BOOL:${BUILD_MEMSET}>:test_memset_s.c>
  $<$<BOOL:${BUILD_MEMZERO}>:test_memzero16_s.c>
  $<$<BOOL:${BUILD_MEMZERO}>:test_memzero32_s.c>
  $<$<BOOL:${BUILD_MEMZERO}>:test_memzero_s.c>
  $<$<BOOL:${BUILD_STPCPY}>:test_stpcpy_s.c>
  $<$<BOOL:${BUILD_STPNCPY}>:test_stpncpy_s.c>
  $<$<BOOL:${BUILD_STRCASECMP}>:test_strcasecmp_s.c>
  $<$<BOOL:${BUILD_STRCASESTR}>:test_strcasestr_s.c>
  $<$<BOOL:${BUILD_STRCAT}>:test_strcat_s.c>
  $<$<BOOL:${BUILD_STRCMPFLD}>:test_strcmpfld_s.c>
  $<$<BOOL:${BUILD_STRCMP}>:test_strcmp_s.c>
  $<$<BOOL:${BUILD_STRCPYFLDIN}>:test_strcpyfldin_s.c>
  $<$<BOOL:${BUILD_STRCPYFLDOUT}>:test_strcpyfldout_s.c>
  $<$<BOOL:${BUILD_STRCPYFLD}>:test_strcpyfld_s.c>
  $<$<BOOL:${BUILD_STRCPY}>:test_strcpy_s.c>
  $<$<BOOL:${BUILD_STRCSPN}>:test_strcspn_s.c>
  $<$<BOOL:${BUILD_STRFIRSTCHAR}>:test_strfirstchar_s.c>
  $<$<BOOL:${BUILD_STRFIRSTDIFF}>:test_strfirstdiff_s.c>
  $<$<BOOL:${BUILD_STRFIRSTSAME}>:test_strfirstsame_s.c>
  $<$<BOOL:${BUILD_STRISALPHANUMERIC}>:test_strisalphanumeric_s.c>
  $<$<BOOL:${BUILD_STRISASCII}>:test_strisascii_s.c>
  $<$<BOOL:${BUILD_STRISDIGIT}>:test_strisdigit_s.c>
  $<$<BOOL:${BUILD_STRISHEX}>:test_strishex_s.c>
  $<$<BOOL:${BUILD_STRISLOWERCASE}>:test_strislowercase_s.c>
  $<$<BOOL:${BUILD_STRISMIXEDCASE}>:test_strismixed_s.c>
  $<$<BOOL:${BUILD_STRISPASSWORD}>:test_strispassword_s.c>
  $<$<BOOL:${BUILD_STRISUPPERCASE}>:test_strisuppercase_s.c>
  $<$<BOOL:${BUILD_STRLASTCHAR}>:test_strlastchar_s.c>
  $<$<BOOL:${BUILD_STRLASTDIFF}>:test_strlastdiff_s.c>
  $<$<BOOL:${BUILD_STRLASTSAME}>:test_strlastsame_s.c>
  $<$<BOOL:${BUILD_STRLJUSTIFY}>:test_strljustify_s.c>
  $<$<BOOL:${BUILD_STRNCAT}>:test_strncat_s.c>
  $<$<BOOL:${BUILD_STRNCPY}>:test_strncpy_s.c>
  $<$<BOOL:${BUILD_STRNLEN}>:test_strnlen_s.c>
  $<$<BOOL:${BUILD_STRNTERMINATE}>:test_strnterminate_s.c>
  $<$<BOOL:${BUILD_STRPBRK}>:test_strpbrk_s.c>
  $<$<BOOL:${BUILD_STRPREFIX}>:test_strprefix_s.c>
  $<$<BOOL:${BUILD_STRREMOVEWS}>:test_strremovews_s.c>
  $<$<BOOL:${BUILD_STRSPN}>:test_strspn_s.c>
  $<$<BOOL:${BUILD_STRSTR}>:test_strstr_s.c>
  $<$<BOOL:${BUILD_STRTOK}>:test_strtok_s.c>
  $<$<BOOL:${BUILD_STRTOLOWERCASE}>:test_strtolowercase_s.c>
  $<$<BOOL:${BUILD_STRTOUPPERCASE}>:test_strtouppercase_s.c>
  $<$<BOOL:${BUILD_STRZERO}>:test_strzero_s.c>
  $<$<BOOL:${BUILD_WCPCPY}>:test_wcpcpy_s.c>
  $<$<BOOL:${BUILD_WCSCAT}>:test_wcscat_s.c>
  $<$<BOOL:${BUILD_WCSCPY}>:test_wcscpy_s.c>
  $<$<BOOL:${BUILD_WCSNCAT}>:test_wcsncat_s.c>
  $<$<BOOL:${BUILD_WCSNCPY}>:test_wcsncpy_s.c>
  $<$<BOOL:${BUILD_WCSNLEN}>:test_wcsnlen_s.c>
  $<$<BOOL:${BUILD_WMEMCMP}>:test_wmemcmp_s.c>
  $<$<BOOL:${BUILD_WMEMCPY}>:test_wmemcpy_s.c>
  $<$<BOOL:${BUILD_WMEMMOVE}>:test_wmemmove_s.c>
  $<$<BOOL:${BUILD_WMEMSET}>:test_wmemset_s.c>
)

add_executable(${PROJECT_NAME}
  ${SOURCES}
)

target_link_libraries(${PROJECT_NAME}
  safestring_static
)

=== debian/changelog ===
fibocom-pc-services (0~git202508291421.319e058-1~ubuntu22.04.1) jammy; urgency=medium

  * Initial release

 -- Kai-Chuan Hsieh <kaichuan.hsieh@canonical.com>  Thu, 04 Sep 2025 14:21:21 +0800

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-modaliases,
+ dh-apparmor,
  cmake,
  build-essential,
  pkg-config,
@@ -21,9 +22,24 @@
 Vcs-Git: https://github.com/fibocom-pc/linux_apps_opensource.git
 Rules-Requires-Root: no
 
+Package: fibocom-pc-services
+Architecture: any
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
+ fibocom-config-service,
+ fibocom-flash-service,
+ fibocom-ma-service
+XB-Modaliases: ${modaliases}
+Description: Service packages for Fibocom Wireless WWAN modules
+ This metapackage installs all services for Fibocom Wireless WWAN modules.
+
 Package: fibocom-helper-service
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, modemmanager
+Provides: oem-fix-wwan-cnl-test-quick-suspend-resume
+Conflicts: oem-fix-wwan-cnl-test-quick-suspend-resume
+Replaces: oem-fix-wwan-cnl-test-quick-suspend-resume
 Description: DBus API provider for Flash/Ma/Config service
  The package provides DBus API for Flash/Ma/Config service to communicate to
  the modem.
@@ -31,14 +47,12 @@
 Package: fibocom-config-service
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
-XB-Modaliases: ${modaliases}
 Description: OEM configuration functions for Fibocom modem
  The service provides OEM configurations functions.
 
 Package: fibocom-ma-service
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
-XB-Modaliases: ${modaliases}
 Description: Provide fccunlock function for Fibocom modem
  The service provides fccunlock function for fibocom modem.
 
@@ -46,6 +60,5 @@
 Architecture: any
 Recommends: fibocom-firmware, fastboot
 Depends: ${shlibs:Depends}, ${misc:Depends}, fibocom-helper-service
-XB-Modaliases: ${modaliases}
 Description: Provide firmware flash function for Fibocom modem
  The service provides firmware flash function for fibocom modem.

=== application/3rd/safestringlib/debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_install:
	install -d usr/lib
	install -m 0644 obj-$(DEB_HOST_MULTIARCH)/libsafestring_shared.so usr/lib
	install -d usr/lib/$(DEB_HOST_MULTIARCH)
	install -m 0644 obj-$(DEB_HOST_MULTIARCH)/libsafestring_static.a usr/lib/$(DEB_HOST_MULTIARCH)
	install -d usr/include/safestring
	install -m 0644 include/* usr/include/safestring/
	dh_install

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)"
